#include <iostream>

#include <map>

using namespace std;

struct test {
	unsigned char elem[2];
	test() {elem[0] = '\0'; elem[1]='\0';}
	test(unsigned char www[2]) {
		elem[0] = www[0];
		elem[1] = www[1];
	}

	test(const test &t) {
		elem[0] = t.elem[0];
		elem[1] = t.elem[1];
	}
	friend bool operator<(const test &t1, const test &t2);
};

bool operator<(const test &t1, const test &t2) {
	if (t1.elem[0] < t2.elem[0])
		return true;
	if (t1.elem[0] == t2.elem[0] && t1.elem[1] < t2.elem[1])
		return true;

	return false;
}


int main(int argc, char *argv[]) {

	map<test, char> testmap;

	unsigned char a[2] = {0, 1};

	testmap.insert(pair<test, char>(test(a), 'a'));
	a[1] = 2;
	testmap.insert(pair<test, char>(test(a), 'b'));
	


	//testmap.insert('a', a);
	//a[1] = 3;
//	testmap.insert(std::pair<char, unsigned char[2]>('b', a);


	for (map<test,char>::iterator it = testmap.begin(); it != testmap.end(); it++) {
		
		cout << (int) (it->first).elem[0] << ", " <<  (int) (it->first).elem[1] << ": " <<  it->second << endl;
	}
	
		

	
	

	return 0;
}

